﻿alter table Version
add last_local_pos int null;

BEGIN;

create table TimeStats_tmp(
				id INTEGER PRIMARY KEY,
	            id_version bigint not null,
	            local_start_time bigint not null,
	            length int not null,
	            word_count int default null,
                send bit not null default 0,
                read_range text null,
                utc_offset int default null,
                last_position_sync datetime default null,
                last_rating_sync datetime default null,
                is_audio int null,
                was_listen bit not null default 0,
				is_finished bit not null default 0,				
	            foreign key (id_version) references Version(id)
            );

INSERT INTO TimeStats_tmp(id_version, local_start_time, length, word_count, send ,read_range, utc_offset, last_position_sync, last_rating_sync ,is_audio, was_listen, is_finished)
SELECT id_version, local_start_time, length, word_count, send ,read_range, utc_offset, last_position_sync, last_rating_sync ,is_audio, was_listen, 1
		FROM TimeStats;

DROP TABLE TimeStats;

ALTER TABLE TimeStats_tmp RENAME TO TimeStats;

CREATE INDEX ix_timestats_send
ON TimeStats (send);

COMMIT;