﻿(function($) {
    $.fn.ellipsis = function() {
        return this.each(function() {
            var el = $(this);
            if (el.css("overflow") == "hidden") {
                var elWidth = el.width();
                if (el.attr("id") == "path") {
                    var t = $(this.cloneNode(true)).css({
                        'position': 'absolute',
                        'width': 'auto',
                        'height': 'auto',
                        'max-height': 'none',
                        'overflow': 'visible',
                        'white-space': 'nowrap'
                    });
                    el.after(t);

                    var spans = t.find("span.ellipsisable").get();

                    spans.sort(function(a, b) {
                        var compA = $(a).width();
                        var compB = $(b).width();
                        return (compA > compB) ? -1 : (compA < compB) ? 1 : 0;
                    });

                    while (t.width() > elWidth) {
                        var first = $(spans[0]);
                        var text = first.html();

                        if (text == "…") {
                            var r = 2;
                            while (t.width() > elWidth) {
                                if (r > spans.length)
                                    break;
                                $(spans[spans.length - r]).remove();
                                r++;
                            }
                            break;
                        }
                        else {
                            text = text.substr(0, text.length - 3) + "&hellip;";
                            first.html(text);

                            for (var i = 1; i < spans.length; i++) {
                                var a = $(spans[i - 1]);
                                var b = $(spans[i]);
                                if (a.width() < b.width()) {
                                    var s = spans[i - 1];
                                    spans[i - 1] = spans[i];
                                    spans[i] = s;
                                }
                                else {
                                    break;
                                }
                            }
                        }
                    }
                }
                else {
                    var origDisplay = el.css("display");
                    el.css("display", "block");
                    var t = $(this.cloneNode(true)).hide().css({
                        'position': 'absolute',
                        'width': el.width(),
                        'height': 'auto',
                        'max-height': 'none',
                        'overflow': 'visible'
                    });
                    el.after(t);

                    var more = el.find("#more").hide();

                    if (t.height() > el.height()) {
                        //var text = el.html();
                        var text = el.text(); // temp
                        var origText = text;
                        var origLength = text.length;

                        var curr = origLength;
                        var prev = 0;
                        var lastOK = curr;

                        while (curr != prev) {
                            var d = Math.floor(Math.abs(curr - prev) / 2);
                            prev = curr;
                            if (t.height() > el.height()) {
                                curr -= d;
                            }
                            else {
                                lastOK = curr;
                                curr += d;
                            }
                            text = origText.substr(0, curr);
                            t.html(text + "&hellip; ");
                            //if (more.length > 0) {
                            //    t.append(more.show());
                            //}
                        }
                        text = origText.substr(0, lastOK);
                        t.html(text + "&hellip; ");
                    }
                    el.css("display", origDisplay);
                }
                el.html(t.html());

                t.remove();
            }
        });
    };
})(jQuery);