﻿var ipadMode = false;
var isAndroid = false;

var chaptPages = {};

browser_id = window.location.search;

String.prototype.endsWith = function (suffix) {
    return this.indexOf(suffix, this.length - suffix.length) !== -1;
};


// <debug>
// </debug>
$.fn.textNodes = function () {
    var ret = [];
    $.each(this[0].childNodes, function () {
        if (this.nodeType == 3 || $.nodeName(this, "br"))
            ret.push(this);
        else
            $.each(this.childNodes, arguments.callee);
    });
    return $(ret);
}

function forceContentDraw(id) {
    console.log("force content draw(" + id + "). this may take some time...");
    if ($("#" + id).width() == 0) {
        console.log("loaded html has 0 width, id=" + id);
    }
    console.log("force content draw(" + id + ") DONE");
}

function fixImages(target, w, h) {
    //console.log("fix images in " + target);
    $("#" + target + " img").each(function() {
        var thisW = $(this).width();
        var thisH = $(this).height();
        if (thisW <= w && thisH <= h)
            return;

        console.log("fix image " + $(this).attr("src") + " " + thisW + "x" + thisH + " to fit in " + w + "x" + h);
        var wScale = w / thisW;
        var hScale = h / thisH;
        var imgRatio = thisW / thisH;
        if (wScale < hScale) {
            thisW = wScale * thisW;    
            thisH = thisW / imgRatio;
        } else {
            thisH = hScale * thisH;
            thisW = thisH * imgRatio;
        }

//        var scale = Math.min(wScale, hScale);
//        thisW = scale * thisW;
//        thisH = scale * thisH;
        console.log("scaled image " + $(this).attr("src") + " to " + thisW + "x" + thisH);
        $(this).css("width", thisW + "px");
        $(this).css("height", thisH + "px");
        $(this).attr("width", thisW + "px");
        $(this).attr("height", thisH + "px");
    });
}

var selectionOps = {
    surroundSiblingsUntil: function (current, commonParent, endParents, dir) {
        var sibling;
        while (current.attr("fp") != commonParent.attr("fp") && current.length > 0) {
            if (endParents.filter(current).length != 0)
                return current;

            if (dir == 1)
                sibling = $(current[0].nextSibling);
            //.nextAll();
            if (dir == -1)
                sibling = $(current[0].previousSibling);
            //();
            var i = 0;
            //  while (i < siblings.length) {
            while (sibling != null && sibling.length != 0) {
                //var sibling = $(siblings[i]);
                if (endParents.filter(sibling).length != 0)
                    break;
                //var span = document.createElement("span");
                //span.setAttribute("style", "background-color: red");
                if (dir == 1)
                    next = $(sibling[0].nextSibling);
                //.nextAll();
                if (dir == -1)
                    next = $(sibling[0].previousSibling);
                //();
               

                if (sibling[0].nodeType == Node.TEXT_NODE) {
                    sibling.wrap('<span class="highlight" />');
                }
                else {
                    sibling.textNodes().filter(function () {
                        return this.nodeType == Node.TEXT_NODE;
                    }).wrap('<span class="highlight" />');
                }
                sibling = next;
                //i++;
            }
            if (endParents.filter(sibling).length != 0)
                return sibling;
            current = current.parent();
        }
    },

    surroundRange: function (range, createElFunc) {
        if (range.startContainer == range.endContainer) {
            var span = document.createElement("span");
            span.setAttribute("class", "highlight");
            range.surroundContents(span);
        }
        else {
            var start = $(range.startContainer);
            var html = start.html();
            var isText = html == null;
            if (html == null)
                html = start.text();
            var txt1 = document.createTextNode(html.substr(0, range.startOffset));
            var span = document.createElement("span");
            span.setAttribute("class", "highlight");
            var txt2 = document.createTextNode(html.substr(range.startOffset));
            span.appendChild(txt2);
            var newHtml = $(txt1).after($(span));

            var commonParent = $(range.commonAncestorContainer);
            var current = start;
            var end = $(range.endContainer);
            var endParents = end.parents();

            var lastParent = surroundSiblingsUntil(current, commonParent, endParents, 1);
            surroundSiblingsUntil(end, commonParent, lastParent, -1);
            start.replaceWith(newHtml);

            html = end.html();
            if (html == null)
                html = end.text();
            txt1 = document.createTextNode(html.substr(0, range.endOffset));
            span = document.createElement("span");
            span.setAttribute("class", "highligh");
            txt2 = document.createTextNode(html.substr(range.endOffset));
            span.appendChild(txt1);
            newHtml = $(span).after($(txt2));

            end.replaceWith(newHtml);

            //if (!isText) {
            //    start.html(newHtml);
            //}
            //else {
            //var parent = start.parent();

            //  start.replaceWith()
            //}
        }
    },

    highlightNode: function (node, color) {
        var width = node.width();
        if (width < 10)
            node.css("width", "10px");
        var height = node.height();
        if (height < 10)
            node.css("height", "10px");
        node.addClass("highlight");
        //node.class("highlight");
        //node.css("background-color", color);
        //node.css("display", "block");
    },

   

    highlightFp: function (startFp, startOffset, endFp, endOffset) {
        var start = $("[fp=" + startFp + "]")[0];
        while ($(start).text() == null || $(start).text().length == 0 || $(start).text().length < startOffset) {
            startOffset -= $(start).text().length;
            start = start.nextSibling;
        }
        var end = $("[fp=" + endFp + "]")[0];
        while ($(end).text() == null || $(start).text().length == 0 || $(end).text().length < endOffset) {
            endOffset -= $(end).text().length;
            end = end.nextSibling;
        }

        try {
            var range = document.createRange();
            range.setStart(start, startOffset);
            range.setEnd(end, endOffset);
            highlightRange(range);
        }
        catch (error) {
            var i = 1;
        }
    },

    highlightRange: function (range) {
        surroundRange(range, null);
    },

    getFpRange: function (range) {
        var startOffset = range.startOffset;
        var start = range.startContainer;

        if (start.nodeName == "#text") {
            start2 = start.previousSibling;
            if (start2 == null)
                start2 = start.parentNode;
            start = start2;
        }
        while (start.nodeName == "#text" || !start.hasAttribute("fp")) {
            if ($(start).text() != null && $(start).text() != "")
                startOffset += $(start).text().length;
            start2 = start.previousSibling;
            if (start2 == null)
                start2 = start.parentNode;
            start = start2;
        }
        var endOffset = range.endOffset;
        var end = range.endContainer;
        if (end.nodeName == "#text") {
            end2 = end.previousSibling;
            if (end2 == null)
                end2 = end.parentNode;
            end = end2;
        }
        while (end.nodeName == "#text" || !end.hasAttribute("fp")) {
            if ($(end).text() != null && $(end).text() != "")
                endOffset += $(end).text().length;
            end2 = end.previousSibling;
            if (end2 == null)
                end2 = end.parentNode;
            end = end2;
        }

        var result =
    {
        startNode: start,
        start: start.getAttribute("fp"),
        startOffset: startOffset,
        endNode: end,
        end: end.getAttribute("fp"),
        endOffset: endOffset
    };
        return result;
    },

    highlightSelection: function () {
        var selection = window.getSelection();

        if (selection != null) {
            var range = selection.getRangeAt(0);

            var fpRange = getFpRange(range);

            highlightRange(range);
            selection.removeAllRanges();
            //selection.collapse();
            //range.surroundContents(newNode);

            $.ajax({
                url: 'cmd/?cmd=select',
                dataType: 'json',
                data: ''
                //+ 'selection=' + escape(selection.toString())
             + '&start=' + fpRange.start + "&startOffset=" + fpRange.startOffset + '&end=' + fpRange.end + "&endOffset=" + fpRange.endOffset + '&file=' + $("#content_new").data('file')
                //success: processServerCmd,
                //error: serverCmdError,
                //complete: awaitServerCmd,
                //timeout: 5000
            });
        }
    }
}

function onMounseUp(event) {
    var el = event.srcElement;
    var node = $(el);
    //var fpnode = nearestFPNode(node, -1);
    //highlightNode(fpnode, "green");
    //var fpnode = nearestFPNode(node, 1);
    //highlightNode(fpnode, "yellow");

    highlightSelection();
}

var serverComm = {
    sid: null,
    keepGoing: true,

    fireCommand: function (cmd, args, success, error, complete) {
        var argsDebug = "undefined";
        if (args != undefined){
            if (args == null)
                argsDebug = "null";
            else if (args.length == 0)
                argsDebug = "0";
            else
                argsDebug = args.length + ", " + args[0];
        }

        var cmdType = success != null || complete != null ? "cmd" : "cmd_async";
        console.log("firecommand " + cmdType + "=" + cmd + ", args=" + args);

        if (args == null) args = [];
        $.ajax({
            url: 'cmd/?' + cmdType + '=' + cmd + "&" + args.join('&') + "&ts=" + Date.now(),
            dataType: 'json',
            data: '',
            success: success,
            error: function(req, type, err){
                console.log("error on while calling command: " + args.join('&') + ", error: " + err);
                if (error != undefined && error != null)
                    error(req, type, err);
            },
            complete: function() {
                console.log("ajax command " + cmd + " completed.");
                if (complete != null) complete();
            }
            //timeout: 5000
        });
    },

    startServerComm: function () {
        getSidThen(this.awaitServerCmd);
    },

    setCookie: function (c_name, value, exdays) {
        var exdate = new Date();
        exdate.setDate(exdate.getDate() + exdays);
        var c_value = escape(value) + ((exdays == null) ? "" : "; expires=" + exdate.toUTCString());
        document.cookie = c_name + "=" + c_value;
    },

    getSidThen: function (thenWhat) {
        serverComm.fireCommand("init", [],
            success = function (d) {
                serverComm.sid = d["sid"];
                serverComm.setCookie("sid", serverComm.sid);
                thenWhat();
            },
            error = this.serverCmdError
        );
        /*$.ajax({
        url: 'cmd/?cmd=init',
        dataType: 'json',
        data: '',
        success: function (d) {
        serverComm.sid = d["sid"];
        serverComm.setCookie("sid", this.sid);
        thenWhat();
        },
        error: serverComm.serverCmdError
        //complete: foobar,
        //timeout: 5000
        });*/
    },

    awaitServerCmd: function () {
        if (!serverComm.keepGoing) return;
        serverComm.fireCommand("wait", ["sid=" + serverComm.sid],
            success = serverComm.processServerCmd,
            error = serverComm.serverCmdError,
            complete = serverComm.awaitServerCmd
        //timeout: 5000
        );

    },


    serverCmdError: function (data, textstats, err) {
        if (data.status == 0 && data.response == "") {
            //server is down - do nothing
        } else {
            console.error("serverCmdError: " + textstats + ":" + data.responseText);
        }
    },

    processServerCmd: function (data) {
        $.each(data, function (key, val) {
            serverComm.processCmd(val);
        });
    },

    processCmd: function (data) {
        /*$.each(data, function (key, val) {
            console.log(key + '=' + val);
        });*/

        if (data.cmd != null) {
            //console.log("COMMAND received:" + data.cmd);
            switch (data.cmd) {
                case "reinit":        		
                    keepGoing = false;
                    serverComm.getSidThen(function() { 
                        window.setTimeout(function() {
                            keepGoing = true;
                            serverComm.awaitServerCmd();
                        }
                        , 50); 
                    } );
                    break;
                case "stop_cmd_loop":
                    serverComm.keepGoing = false;
                    break;
                case "start_cmd_loop":
                    window.setTimeout(serverComm.awaitServerCmd, 50);
                    break;
                case "next":
                    pageOps.nextPage();
                    break;
                case "prev":
                    pageOps.prevPage();
                    break;
                case "highlight":
                    for (var i in data.arg) {

                        var range = data.arg[i];
                        var start = range.start;
                        var startOffset = range.startOffset;
                        var end = range.end;
                        var endOffset = range.endOffset;

                        selectionOps.highlightFp(start, startOffset, end, endOffset);

                    }
                    break;
                case "clear_div":
                    
                    break;
                case "load_html_array":
                    var targets = data.arg.targets;
                    
                    if (targets.length > 0) {
                        var designated = data.arg.designated;
                        var target = designated;
                        var last = targets[targets.legth-1];
                        
                        $("#" + last).ready(function () {
                            //	serverComm.fireCommand("html_loaded"); 
                            window.setTimeout(function() { 
                                //pageOps.calculateColumns();
                                var param = pageOps.getChapterPages(target);
                                serverComm.fireCommand("html_ready", ["page="+param]); 
                            }, 100);
                        });
                        var i=0;
                        for (i=0;i<=targets.length;i++)
                        {
                            var id = targets[i].id;
                            var html = targets[i].html;
                            $("#" + id).html(html);
                            //if (isAndroid) 
                            {
                                forceContentDraw(id);
                                fixImages(id, pagingSize.columnWidth, pagingSize.height);
                            }
                        }
                    }
                    break;
                case "load_html":
                    var target = data.arg.target;
                    console.log("load_html start. target=" + target);
                    //var html = data.arg.html;
                    var append = data.arg.append;
                    //html += '<script>serverComm.fireCommand("html_loaded");</script>';
                    //serverComm.log("load_html into" + target);

                    var trgt = $("#" + target); // document.getElementById(target); 
                    trgt.ready(function () {
                        console.debug('html is ready: ' + target + '. setting css display.');
                        $("#"+target+"_placeholder").css("display", "none"); 
                        trgt.css("display", "block");
                        console.debug('display set for '+target+'. enquing getChapterPages and html_ready command');
                        //	serverComm.fireCommand("html_loaded");

                        var reportLoaded = function() 
                        { 
                            console.debug('reportLoaded: getChapterPages');
                            //pageOps.calculateColumns();
                            var pages = pageOps.getChapterPages(target);
                            console.debug('reportLoaded: fillPlaceholder');
                            //$("img.lazy").lazyload();
                            pageOps.fillPlaceholder(pages);
                            console.debug('reportLoaded: fireCommand html_ready');
                            serverComm.fireCommand("html_ready", 
                                ["start_page=" + pages.start_page, "end_page=" + pages.end_page, "target=" + pages.target]
                                //,complete = function() { return 0; }
                                );
                            //window.setTimeout(function () {
                            //    misc.loadImages();
                            //}, 1500);
                        }; 
                        //reportLoaded();
                        // give the load_html command time to return
                        window.setTimeout(reportLoaded, 200);
                    });

                    console.log("load_html setting inner html in " + target);
                    if (append == 'true')
                        document.getElementById(target).innerHTML += data.arg.html;
                        //$("#" + target).html($("#" + target).html() + html);
                    else
                        document.getElementById(target).innerHTML = data.arg.html;
                        //$("#" + target).html(html);

                    console.log("load_html: set inner html done for " + target + ". rendering...");
                    //if (isAndroid) 
                    {
                        forceContentDraw(target);
                        console.log("load_html: fixxing images");
                        fixImages(target, pagingSize.columnWidth, pagingSize.height);
                    }
                    console.log("load_html: " + target + " rendering DONE.. DONE.");
                    /*$("#" + target).load(function () {
                            
                            var end_node = $("#" + target + "_end");
                            var end_pos = -1;
                            if (end_node.length > 0) {
                                end_pos = pageOps.getPageForElement(end_node);
                            }
                            
                            serverComm.fireCommand("html_loaded", ["end_page=" + end_pos, "target=" + target]); 
                    });*/
                    break;
                case "eval":
                    var command = data.arg.command;
                    var order = data.arg.order;

                    console.log("processCmd eval cmd=" + command + "start");
                    var result = eval(command);
                    console.log("processCmd eval cmd=" + command + "end");
                    serverComm.fireCommand("eval_result", ["result=" + result, "order=" + order]); 
                    break;
                case "eval_no_result":
                    //eval(data.arg.command);
                    //var command = data.arg.command;
                    //var result = eval(command);
                    //serverComm.fireCommand("eval_result", ["result=" + result]); 
                    break;
                case "set_font_size":
                    var target = data.arg.target;
                    var size = data.arg.size;	
                    var old_h = $("#"+"chapt_0_placeholder").height();
                    $("#"+target).css("font-size", size);
                    //                    var dest = $("#" + target);
//                    var tempClass = "temp" + new Date().getTime();
//                    var tempDiv = $("<div></div>").addClass(tempClass).appendTo(dest);

//                    var indexVal = size;// new Date().getTime();
//                	dest.css("font-size", size);
//                    //dest.css("z-index", indexVal);
//                    //dest.css("color", "red");
//                    var cssp_interval = setInterval(function() {
//                            // if the zIndex is applied, we know the css has loaded
//                            var curr = tempDiv.css("fontSize");
//                            console.log("curr=" + curr + ", expected=" + indexVal);
//                            if (curr == indexVal ) {
//                                tempDiv.remove();
//                                // callback:
//                                //alert("font set");
//                                clearInterval(cssp_interval);
//                            }
//                        }, 1000);
                    //pageOps.pollForSizeChange($("#"+"chapt_0_placeholder"), old_h, 100); 
                    break;                                            
                case "get_property":
                    var name = data.arg.name;
                    return properties[name];
                    break;
                case "set_property":
                    var name = data.arg.name;
                    var val = data.arg.value;
                    properties[name] = val;
                    break;
                case "get_chapters_pages":
                    console.log("fire html_ready from get_chapters_pages");
                    var p = pageOps.getChaptersPages(); 
                    serverComm.fireCommand("html_ready", p); 
                    break;
                case "get_chapter_pages":
                    console.log("fire html_ready from get_chapters_pages");
                    var p = pageOps.getChapterPages(); 
                    serverComm.fireCommand("html_ready", p); 
                    break;
                case "load_css":
                    var href = data.arg.href;
                    misc.loadCssFile(href);
                    break;
                case "load_image":
                    var id = data.arg.id;
                    var node = $("#" + id);
                    setTimeout(function () {
                        console.log('doing misc.loadImage in setTimeout');
                        misc.loadImage(node);
                        console.log('END misc.loadImage');
                    }, 50);
                    break;
            }
        }
    },

    fireReady: function () {
        serverComm.fireCommand("ready");
    },

    log: function (msg) {
        serverComm.fireCommand("log", ["msg=" + msg]);
    },

    getSid: function () {
        if (document.cookie && document.cookie != '') {
            var split = document.cookie.split(';');
            for (var i = 0; i < split.length; i++) {
                var name_value = split[i].split("=");

                name_value[0] = name_value[0].replace(/^ /, '');
                if (name_value[0] == "sid")
                    return name_value[1];
            }
        }
    },

    get_cookies: function () {
        var cookies = {};

        if (document.cookie && document.cookie != '') {
            var split = document.cookie.split(';');
            for (var i = 0; i < split.length; i++) {
                var name_value = split[i].split("=");
                name_value[0] = name_value[0].replace(/^ /, '');
                cookies[decodeURIComponent(name_value[0])] = decodeURIComponent(name_value[1]);
            }
        }

        return cookies;

    }

}

var pagingSize = {
    width: 800,
    page_width: 800,
    height: 600,
    columnWidth: 0,
    columnGap: 20,
    columnsOnPage: 2,
    adjust: 1,
    adjusted_page_width: 420
}

var events = {
    hrefClicked: function(href)
    {
        serverComm.fireCommand('href_clicked', ['href='+href]);
    },
    imageClicked: function(src, id) {
        //var src = $(this).attr("src");
        //var id = $(this).attr("id");
        
        serverComm.fireCommand("img_clicked", ["src=" + src, "id=" + id]);
    },
    
    imageLoaded: function(el, src, id, enableCallback) {
        if (!el.src.endsWith("/loading.gif")) {        
	        if (isAndroid)
	            events.setAndroidImgClick(el, src, id);
	        else
	            events.setImgDblTap(el, src, id);
	        if (enableCallback)
            	serverComm.fireCommand("img_loaded", ["src=" + src, "id=" + id]);
        } else {
        
        }
    },

    setAndroidImgClick : function (el, src, id) {
        $(el).click(function() {
            events.imageClicked(src, id);      
        });
    },
    
    setImgDblTap: function(el, src, id)
    {
         $(el).doubletap(
                /** doubletap-dblclick callback */
                function(event){
                    events.imageClicked(src, id);
                    //alert('double-tap');
                },
                /** touch-click callback (touch) */
                function(event){
                    //alert('single-tap');
                },
                /** doubletap-dblclick delay (default is 500 ms) */
                200
            );
    }
    
}


 var cssCounter = 0;
    var cssInFlight = {};
    var cssInFlightIntvl = null;
    var cssStartTime = 0;
    var idPrefix = "RequireCss";

    var _watchCssInFlight = function () {
        //summary: watches to make sure all css files have loaded.

        //console.log("check for css load, count=" + cssInFlight.length);
        var stillWaiting = false;
        var files = "";
        for (var param in cssInFlight) {
        	
            //Protect against bad JS modifying Object.prototype
            if (typeof param == "string" && param.indexOf(idPrefix) == 0) {
            	
                //console.debug(cssInFlight[param].sheet);
                //if (cssInFlight[param].sheet == undefined || cssInFlight[param].sheet == null)
                //    continue;

                files += cssInFlight[param].href + " ";
                if (cssInFlight[param] != null && cssInFlight[param].sheet != null && cssInFlight[param].sheet.cssRules) {
                    //Since moz and safari do not work with onload callbacks on the link
                    //tag, see if the sheet and sheet.cssRules exist. If so, then assume
                    //the css file has be loaded.
                    delete cssInFlight[param];
                }
                else if ($("head link[href^='" + cssInFlight[param].href + "']").length == 0)
                {
                    // the css has been removed before being loaded
                    delete cssInFlight[param];
                }
                else
                {
                    stillWaiting = true;
                    console.log("still waiting for css: " + cssInFlight[param].href);
                }
            }
        }
        files += "";

        if (stillWaiting) {
            //Make sure we have not reached the timeout stage.
            var waitInterval = (15) * 1000;
            if ((cssStartTime + waitInterval) < (new Date()).getTime()) {
                var err = "Timed out waiting for css files: ";
                for (param in cssInFlight) {
                    err += cssInFlight[param].href + " ";
                }
                throw err;
            }
        } else {
            //All loaded. Clean up.

            clearInterval(cssInFlightIntvl);
            cssInFlightIntvl = null;
            misc.cssLoaded(files);
        }
    }

    var misc = {

        loadCssFile: function (path) {
            //summary: Converts the resource name ("some.thing") to a CSS URL
            //(http://some.domain.com/path/to/some/thing.css), then adds the CSS file
            //to the page. Full urls can be passed in (instead of a "some.thing" resourceName.
            //It also registers this CSS file with the dojo loader. This
            //means that if you do a dojo.addOnLoad() callback after calling this function,
            //the addOnLoad callback will not be fired until the CSS file has loaded.
            //Note that style sheets may be evaluated in a different order than the order
            //they appear in the DOM. If you want precise ordering of style rules, make
            //one call to this function, then in a dojo.addOnLoad() callback, load the other,
            //and repeat this call structure until you load all the stylesheets.
            //Example:
            //		dojo.requireCss("some.thing");
            //		dojo.requireCss("http://some.domain.com/path/to/some/thing.css");

            //Translate resource name to a file path
       

            //Create the link node

            $("head").append("<link>");
            var link = $("head").children(":last");
            var id = idPrefix + (cssCounter++);
            link.attr({
                rel: "stylesheet",
                type: "text/css",
                href: path,
                id: id
            });

            cssInFlight[id] = link[0];

            console.debug("load css: " + id + " created for file " + path );

            var cssInFlightInterval = 350;
            var browser = navigator.userAgent;

            var webkit = "AppleWebKit/";
            var index = browser.indexOf(webkit);
            //dirty hack for problems with loading css on ios 8.x
            if(index != -1)
            {
                var browserVersion = browser.substring(index+webkit.length,index+webkit.length+3);
                if(browserVersion >=600)
                cssInFlightInterval = 3000;
            }
            console.debug("cssInFlightInterval: " + cssInFlightInterval );

            //Start the inflight watch.
            cssStartTime = (new Date()).getTime();
            if (!cssInFlightIntvl) {
                cssInFlightIntvl = setInterval(_watchCssInFlight, cssInFlightInterval);
            }
        
        },
        /*
        loadCssFile: function (file) {
            $("head").append("<link>");
            var css = $("head").children(":last");
            css.attr({
                rel: "stylesheet",
                type: "text/css",
                href: file
            }); 
            misc.cssLoaded(file);
            return "";
        },*/
   
        unloadCssFile: function (file) {
            var f = $("head link[href^='" + file + "']");
            if (f.lenght != 0)
            { 
                console.debug('unloading css: ' + file);
                f.remove();
            }
            else 
            {
                console.debug('tried to unload non-existing css: ' + file);
            }
            return "";
        },

        clearCssRefs: function () {
            /// works in Opera
            $("head link[type='text/css']").remove();
        },
        cssLoaded : function (file)
        {
            console.debug("CSS " + file + " loaded");
            //var p = pageOps.getChaptersPages(); 
            serverComm.fireCommand("css_ready",  ["href=" + file]); 
        },

        loadImages: function () {
            $("img").eachAsync({
            	bulk: 1, 
                loop: function () {
                    misc.loadImage($(this));
                }
            });
        },
        loadImage: function (node) {
        	node.attr("src", node.attr("data-original"));
        	//node.attr("src", "http://192.168.12.11:8098" + node.attr("data-original"));
            //node.css("background", "url(\"http://192.168.12.11:8098" + node.attr("data-original") + "\")");
        },
  }


var pageOps = {
    //pageWidth: 320,
    //currPage: 0,
    debug : false,
    prevPage: function () {
        currPage--;
        //$(this).scrollLeft(320 * currPage);
        $("#paging").css("left", -columnWidth * currPage);
        info.html("total pages = " + columnCount + "<br/>current page = " + (currPage + 1) + "<br/>");
        serverComm.fireCommand("page", ["p=" + currPage]);
    },

    nextPage: function () {
        currPage++;
        //$(this).scrollLeft(320 * currPage);
        content.css("left", -columnWidth * currPage);
        //info.html("total pages = " + columnCount + "<br/>current page = " + (currPage + 1) + "<br/>");
        //serverComm.fireCommand("page", ["p=" + currPage]);
    },

    assignPages: function () {
        $("[fp]").each(function () {
            $(this).attr("p", pageOps.getPageForElement($(this)));
        });
    },
    
    

    nearestFPNode: function (node, dir) {
        if (dir == 1) {
            //if (node.attr("fp") != null)
            //	return node;
            var n2 = node.next("*[fp]");
            if (n2 == null || n2.length == 0) {
                n2 = node.children().first();
                if (n2 == null || n2.length == 0) 
                    return null;
                if (n2.attr("fp") != null)
                    return n2;
                else            	
                    n2 = pageOps.nearestFPNode(n2, dir);
            }
            return n2;
        }
        else if (dir == -1) {
            var n2 = node.prev("*[fp]");
            return n2;
        }
    },

    firstNodeOnCurPage: function(target_page, attrName, pageOffset, exact)
    {
        console.log("firstNodeOnCurPage target_page=" + target_page + ", attrName=" + attrName + ", pageOffset=" + pageOffset + ", exact=" + exact);
        var node = pageOps.edgeNodeOnCurPage(1, target_page, attrName, pageOffset, exact);
        console.log("firstNodeOnCurPage END. node=" + (node != null ? node[0] : "NULL") );
        return node;
    },
    lastNodeOnCurPage: function(target_page, attrName, pageOffset, exact)
    {
        console.log("lastNodeOnCurPage target_page=" + target_page + ", attrName=" + attrName + ", pageOffset=" + pageOffset + ", exact=" + exact);        
        return pageOps.edgeNodeOnCurPage(-1, target_page, attrName, pageOffset, exact);
        console.log("lastNodeOnCurPage END");

    },



    edgeNodeOnCurPage: function(dir, target_page, attrName, pageOffset, exact)
    {
        console.log("edgeNodeOnCurPage dir=" + dir + " page=" + target_page);

        var firstPage = target_page;
        var lastPage = firstPage + (pagingSize.columnsOnPage - 1);

        console.log("edgeNodeOnCurPage firstPage=" + firstPage + " lastPage=" + lastPage);

        var allElementsWithAttr = $('[' + attrName + ']');

        console.log("edgeNodeOnCurPage number of elements with attribute " + attrName + ": " + allElementsWithAttr.length);

        var matchIdx = null;
        var leftIdx = 0, rightIdx = allElementsWithAttr.length - 1;
        var iterations = 0;

        if (dir > 0) {

            while (leftIdx <= rightIdx) {

                iterations++;

                //console.log("l=" + leftIdx + " r=" + rightIdx);

                var middleIdx = Math.floor((leftIdx + rightIdx) / 2);
                var middleElement = allElementsWithAttr.get(middleIdx);
                //console.log((middleElement == null) ? "NULL element!" : middleElement.outerHTML);
                var middleElementPage = pageOps.getPageForElement($(middleElement));

                if (firstPage == middleElementPage) {
                    matchIdx = middleIdx;
                    rightIdx = middleIdx - 1;
                    continue;
                }

                if (middleElementPage < firstPage) {
                    leftIdx = middleIdx + 1;
                } else {
                    rightIdx = middleIdx - 1;
                }
            }
        } else if (dir < 0) {
            
            while (leftIdx <= rightIdx) {

                iterations++;

                var middleIdx = Math.floor((leftIdx + rightIdx) / 2);
                var middleElement = allElementsWithAttr.get(middleIdx);
                var middleElementPage = pageOps.getPageForElement($(middleElement));

                if (lastPage == middleElementPage) {
                    matchIdx = middleIdx;
                    leftIdx = middleIdx + 1;
                    continue;
                }

                if (middleElementPage < lastPage) {
                    leftIdx = middleIdx + 1;
                } else {
                    rightIdx = middleIdx - 1;
                }
            }
        } else {
            return ["DIR == 0;"];
        }

        if (matchIdx == null) {
            return [null];
        }

        var resultElement = allElementsWithAttr.get(matchIdx);
        console.log("edgeNodeOnCurPage: matchIdx=" + matchIdx + " html=" + resultElement.outerHTML + " after " + iterations + " iteration(s)");
        return [$(resultElement)];

        /*
        if (dir < 0) dir = -1;
        if (dir > 0) dir = 1;
        if (dir == 0) return ["DIR == 0!"];

        var y_step = dir * 10;
        var x_step = dir * 40;

        var consoleDebug = true;
		var debug_str = null;
 		//var debug_str = "edgeNodeOnCurPage:_target_page=" + target_page + "_offset=" + pageOffset + "_";
        
        var top_offset = dir > 0 ? $("#content_new").position().top : $("#content_new").height();

        var left_offset = dir > 0 ? x_step : pagingSize.width - x_step;

        console.log("edgeNodeOnCurPage topOffset=" + top_offset + ", leftOffset=" + left_offset);

        if (pageOffset != null)
        {
            //console.log("edgeNodeOnCurPage left_offset += " + pageOffset + " * (" + pagingSize.columnWidth + " + 2 * " + pagingSize.columnGap + ")");
            left_offset += pageOffset * (pagingSize.columnWidth + 2 * pagingSize.columnGap);
            console.log("edgeNodeOnCurPage left_offset=" + left_offset);
            if (target_page != null)
                target_page += pageOffset;
        }

        if (target_page != null && dir < 0)
        {
           target_page += (pagingSize.columnsOnPage - 1);
        }

        console.log("edgeNodeOnCurPage dir=" + dir + " adjusted target_page=" + target_page);

        var el = null;
       
        var y_offset = y_step; 
        var x_offset = x_step; 
       
        var prev_el = null;

        var bestFit = null;
        var bestFitPage = null;
        var it = 0;

        do {
            console.log("edgeNodeOnCurPage: it[" + it + "] (" + (left_offset + x_offset) +", "+ (top_offset + y_offset) + ")");
            el = document.elementFromPoint(left_offset + x_offset, top_offset + y_offset);
            if (debug_str != null || consoleDebug) 
            {
            	msg = (el != null && el != prev_el ? 
    				(el.nodeName + ".val=" + $(el).attr(attrName) + " @" + pageOps.getPageForElement($(el)) 
            		+ "{"+(left_offset + x_offset)+","+(top_offset + y_offset)+"}" )
                    : "^"
                    )            		
            	+  (el != prev_el ? ":" : "|");            	
                if (debug_str != null) 
                    debug_str += msg;
                if (consoleDebug)
                    console.log(msg);
            }
            if (el != prev_el)
            {
                if (el != null && el.hasAttribute(attrName))
                {
                    var elPage = pageOps.getPageForElement($(el));
                    if ((target_page == null || elPage == target_page))
                    {
                        if (consoleDebug && debug_str != null) {                        
                            console.log("edgeNodeOnCurPage: return " + debug_str);
                        }
                        if (debug_str != null) {
                            return [$(el), debug_str];
                        }
                        return [$(el)];//.attr(attrName);
                    }
                    else 
                    {
                        console.log("edgeNodeOnCurPage: el page " + elPage + " != " + target_page + " target page");
                        if (bestFitPage == null 
                        || Math.abs(elPage - target_page) < Math.abs(bestFitPage - target_page)) 
                        {
                            bestFit = el;
                            bestFitPage = elPage;
                        }
                    }
                }
                else 
                {
                    console.log("edgeNodeOnCurPage: element has no attribute named '" + attrName + "'");
                }
            }
            else 
            {
                console.log("edgeNodeOnCurPage: el == prevEl. ignore");
            }
            if (exact == null || !exact)
            {
                y_offset += y_step;
                /// add same step to x and y
                x_offset += y_step;
            } else 
            {
                x_offset += x_step;

                if ( (dir >= 0 && x_offset + left_offset >= pagingSize.columnWidth)
                    || (dir <= 0 && x_offset + left_offset <= (pagingSize.columnWidth * (pagingSize.columnsOnPage-1)) ))
                {
                    x_offset = x_step;
                    y_offset += y_step;
                }
            }
            prev_el = el;
            it++;
        } while (
            ((dir > 0 && y_offset < 300) 
            || (dir < 0 && top_offset + y_offset > 0))
            && it < 15
            );

        if (bestFit != null) {
            console.log("edgeNodeOnCurPage: iteration limit reached. using best fit element");
            el = bestFit;
        }

        if (debug_str != null) {
            console.log("edgeNodeOnCurPage: return " + debug_str);
            return [ $(el), debug_str ];
        }
        
        if (exact == true)
        {
            console.log("edgeNodeOnCurPage: exact = true. return NULL");
        	return [null];
    	}
		else
		{
			console.log("edgeNodeOnCurPage: return el:" + el);
        	return [$(el)];//.attr(attrName);
    	}*/

    },


  
    getCurrentWc: function(target_page)
    {
        try {
        console.log("getCurrentWc " + target_page);
        var result = "";

        var n1 = pageOps.firstNodeOnCurPage(target_page, "wc", 0, true);
        var el1 = n1 != null ? n1[0] : null;
        var wc1 = el1 != null ? el1.attr("wc") : "X";
        //var wc2 = pageOps.firstNodeOnCurPage(target_page, "wc", pagingSize.columnsOnPage, true);
        var n2 =  pageOps.lastNodeOnCurPage(target_page, "wc", 0, true);
        var el2 = n2 != null ? n2[0] : null;
        var wc2 = el2 != null ? el2.attr("wc") : "X";

        if (wc1 == null) result += "NULL";
        else result += wc1;
        result += ";";
        if (wc2 == null) result += "NULL";
        else result += wc2;
        result += ";";

        
        return result;
        } catch(e) {
            console.log("exception in getCurrentWc:" + e);
            throw e;
        }
    },

     getCurrentFp: function(target_page, offset)
    {
    try {
        console.log("getCurrentFp: target_page=" + target_page + ", offset=" + offset);
        var t = pageOps.firstNodeOnCurPage(target_page, "fp", offset);
        if (t == null) {
            console.log("getCurrentFp: firstNodeOnCurPage not found! getCurrentFp END");
            return "";
        }
        var el = t[0];
        var r = el.attr("fp") + " " + el.attr("wc");
        console.log("getCurrentFp: t.length=" + t.length);
        if (t.length > 1)
           r = r + " " + t[1];
		
        console.log("getCurrentFp END  r=" + r);
		return r;
        } catch(e) {
        console.log("exception in getCurrentFp: " + e);
        throw e;
        }
        /*
        var top_offset = $("#content_new").position().top;
        var y_offset = 10; 
        var el = null;
        var debug_str = null;
        do {
            el = document.elementFromPoint(20 + y_offset, top_offset + y_offset);
            if (el != null && el.hasAttribute("fp") && (target_page == null || pageOps.getPageForElement($(el)) == target_page))
                return $(el).attr("fp");// + ' id:' +  $(el).attr("id") + ' html:' + $(el).html();
            //else 
                //debug_str += '\r\n' + $(el).attr("fp") + ' id:' +  $(el).attr("id") + ' html:' + $(el).html() + ' page:' +  pageOps.getPageForElement($(el)) + '@' + (20 + y_offset) + ' ' + (top_offset + y_offset); 
            y_offset += 10;
        } while (y_offset < 300);
        //return 'not found. last el:' + debug_str;// + $(el).attr("fp") + ' id:' +  $(el).attr("id") + ' html:' + $(el).html();;
        return $(el).attr("fp");//+ ' id:' +  $(el).attr("id") + ' html:' + $(el).html() + ' approximated:' + debug_str;
        */
    },

    firstNodeOnPage : function(pageNo, chaptId) {
        var startNode = null;
        if (chaptId != undefined && chaptId != null)
        {
            var chaptIdStr = chaptId + "_start";
            //console.log("chapter id=" + chaptIdStr);
            var start = $("#" + chaptIdStr);
            if (start.length > 0)
            {
                startNode = start;
                //console.log("got chapter start node");
            }
        }
        
        if (startNode == null)
            startNode = $("[fp]").first();

        return pageOps.firstNodeOnPage_rec(pageNo, startNode, 0);
    },
    
    getNodeDebugName: function(curNode) {
        var nodeName = "undefined";
        if (curNode != undefined)
        {
            if (curNode != null && curNode.length > 0)
                nodeName = "fp:" + curNode.attr("fp");
            else
                nodeName = "null";
        }
        return nodeName;
    },

    firstNodeOnPage_rec : function(pageNo, curNode, level) {
        var nodeName = this.getNodeDebugName(curNode);
        //console.log("page=" + pageNo + ", cur=" + nodeName + ", level=" + level);

        if (curNode == null || curNode.length == 0) {
            if (pageOps.debug) return "no-curNode"; 
            return curNode;
        }
        var page = -1;
        var r = ""
        /// in safari, some top-level divs that don't directly contain text have strange position
        /// if (position().top < 0 && height > pagingSize.height), its probably this case
        /// so this node can't be a direct hit and if the page is greater than the target pageNo,
        /// it doesn't mean that children can't have page=pageNo
        if (curNode.position().top >= 0 || curNode.height() <= pagingSize.height)
        {
            page = pageOps.getPageForElement(curNode);
            //console.log("cur page=" + page);

            r = curNode.attr("fp") + "@" + page + "|";
            if (page == pageNo) {
                if (pageOps.debug)  return "direct-hit:"+ curNode.attr("fp");
                return curNode;
            }
            // in safari, some top-level divs that don't directly contain text have strange position
            if (page > pageNo) {
                if (pageOps.debug) return "too-far";
                return null;
                /// get back
            }
        }
        
        /// process all siblings of current element
        /// stop when the next sibling has page > pageNo
        /// - this means the previous one contains some child element that should be on pageNo
        //if (page < pageNo) 
        {
            var n1 = null;
            var cur = curNode;
            do {
                if (cur.attr("fp") != undefined)
                    n1 = cur;
                var n = $(cur[0].nextSibling);
                cur = n;

                if (cur == null || cur.length == 0) {
                    if (pageOps.debug) r += "no-more-siblings" + n1.attr("fp") + "|";
                    break;			
                }
                if (cur.attr("fp") == undefined) {
                    //if (pageOps.debug) r = r + "skip" + cur[0];
                    //if (pageOps.debug) r += "s=" + cur[0].nextSibling;
                    continue;	
                }

                page = pageOps.getPageForElement(cur);
                //console.log("moved to node=" + this.getNodeDebugName(cur) + ", page=" + page);
                if (page == pageNo && cur.position().top >= 0 && cur.height() <= pagingSize.height) {
                    // we're lucky
                    //console.log("direct hit");
                    if (pageOps.debug) return "direct-hit-on-sibling:" + cur.attr("fp");
                    return cur;
                }
                if (page < pageNo) {
                    if (pageOps.debug) r += cur.attr("fp") + "@"+ page +"<|";
                } else {
                    if (pageOps.debug) r += cur.attr("fp") + "@"+ page + ">|";
                }
                    
            } while (page < pageNo);
            //if (n1 == curNode) {				
                // nothing changed - need to get this node's children
                // same as the next case
            //} else 
            
            {
                // go back one node and look deeper
                // unless the previous node has id ending with _start
                // if it is a direct hit, it should be detected earlier
                // if it is not - this means it is chapt_id_start, with no children 
                // so we prefere current node
                if (n1[0].id.endsWith("_start"))
                    n1 = cur;
                var ch = n1.children().first();

                if (ch == null || ch.length == 0) {
                    // no children? - is this the node we are looking for?
                    //console.log("no more children, return " + this.getNodeDebugName(n1));
                        if (pageOps.debug) return n1.attr("fp") + ":no-more-children:";
                        return n1;
                }
                if (pageOps.debug) r += "" + ch.attr("fp") + "|>>|";
                var n = null;
                if (pageOps.debug) n = r + pageOps.firstNodeOnPage_rec(pageNo, ch, level+1);
                else n = pageOps.firstNodeOnPage_rec(pageNo, ch, level+1);
                
                if (level == 0 && 
                        ( (n != null && n.length > 0 && n.position != undefined && n.position() != null) 
                          || (pageOps.debug && n.endsWith(":no-more-children:")) )
                    ) {
                    //page = pageOps.getPageForElement(n);
                    //console.log("try next sibling");
                    if (pageOps.debug) n += "!try-next-sibling!";
                    if (cur != null && cur.length > 0)
                    {
                        //try the next sibling to be sure (some bug in iOS webkit? sometimes chapter's div position is wrong)
                        var n2 = pageOps.firstNodeOnPage_rec(pageNo, cur.children().first(), level+1);
                        if (n2 != null && n2.length > 0) {
                            if (n.position != undefined && n.position() != null) {
                                var page2 = pageOps.getPageForElement(n2);
                                if (page2 == pageNo)
                                    n = n2;
                            } 
                            else if (pageOps.debug) {
                             n += n2;
                            }
                        }
                    }
                }
                
                return n;
            }
            
            
            //pageOps.firstNodeOnPage_rec(pageNo, curNode, maxPage);
            //var child = curNode.children().first();			
        }
        
        return "upss..";
            
    },
    
    fillPlaceholder: function (pages) {
        var target = pages.target;
        var start_pos = pages.start_page;
        var end_pos = pages.end_page;
        
        var prev = chaptPages[target];
        if (prev != null && prev.start_page == start_pos && prev.end_page == end_pos && pages.last_page_reduced == prev.last_page_reduced)
            return;
        if (pages.last_page_reduced) 
            end_pos++;

        var placeholder_html = "";
        //placeholder_html += "<div style='border: solid blue 1px'>" + target + "</div>";
        placeholder_html += '<div style="height:1px;"><p>&nbsp;</p></div>';
        for(var i = 0; i < end_pos - start_pos; i++)
        {
            placeholder_html += '<div style="-webkit-column-break-before:always; width: 0px; height: 0px; column-break-before:always; break-before:column;"></div>';
            //if (debug)
           // placeholder_html += "<div style='border: solid blue 1px'>" + target + "</div>";
            placeholder_html += '<div style="height:1px; "><p>&nbsp;</p></div>';
        }
        $("#" + target + "_placeholder").html(placeholder_html);	                    	
    },
    
    getChapterPages_str : function(chapt_id) {
        var p = pageOps.getChapterPages(chapt_id);		
        pageOps.fillPlaceholder(p);
         var start_pos = p.start_page;
        var end_pos = p.end_page;

        return start_pos + '-' + end_pos;
    },
    
    getChapterPages: function(chapt_id) {

            console.log("getChapterPages start id=" + chapt_id);

            var start_node = $("#" + chapt_id + "_start");
            var start_pos = -2;
            if (start_node.length > 0) {
                start_pos = pageOps.getPageForElement(start_node);
                //start_pos = start_node[0].offsetLeft;
            }

            var end_node = $("#" + chapt_id + "_end");
            var end_pos = -2;
            var last_page_reduced = false;
            if (end_node.length > 0) {
                end_pos = pageOps.getPageForElement(end_node);
                //end_pos = end_node[0].offsetLeft;
                var top = $("#content_new").css("padding-top");
                var end_top = end_node.position().top;
                 if (end_pos > start_pos &&
                 ((end_top + "px") == top || ((end_top-1) + "px") == top))
                {
                    if($("#" + chapt_id).css("display") == "block" || end_node.css("-webkit-column-break-after") == "auto")
                    {
                        end_node.css("-webkit-column-break-after", "auto");
                        //end_node.css("border: solid 2px red");
                        end_pos--;
                        last_page_reduced = true;
                    }
                    
                } else 
                {
                    end_node.css("-webkit-column-break-after", "always");
                    //end_node.css("border: solid 2px blue");
                    last_page_reduced = false;
                }
            }
           
            //if (end_pos < 0) {
            //	end_node = $("#" + chapt_id + "_placeholder");
            //	if (end_node.length > 0)
            //		end_pos = pageOps.getPageForElement(end_node);
            //}
            
            
            //if (start_pos < 0) {
            //	start_pos = end_pos;
            //}
            
            if (start_pos > 0 && (end_pos <= 0 || end_pos == null || end_pos == undefined))
            {
                //end_pos = 10;
                var e = $("#content_end");
                var last_page = pageOps.getPageForElement(e);
                end_page = last_page;
            }
         var pos = { start_page: start_pos, end_page: end_pos, target: chapt_id, last_page_reduced: last_page_reduced };
        pageOps.fillPlaceholder(pos);
        chaptPages[chapt_id] = pos;

        console.log("getChapterPages end id=" + chapt_id + ". pages=" + pos.start_page + " - " + pos.end_page);

        return pos;
    },
    
    getChaptersPages: function() {

        console.log("getChaptersPages start");

        var end_nodes = "";
        var start_nodes = "";
        var ids = "";
        var chapters = $("div[chapt_id]");
        chapters.each(function() {
            console.log("getChaptersPages start process id=" + this.id);
            var pos = pageOps.getChapterPages(this.id);
            end_nodes += pos.end_page + ",";
            start_nodes += pos.start_page + ",";
            ids += pos.target + ",";
            console.log("getChaptersPages ended process id=" + this.id);
        });
        
        return "start_page=" + start_nodes + ";" +
                         "end_page=" + end_nodes +";" + "target=" + ids + ";";
    },

    getFirstFpOnPage : function(pageNo, chaptId) {
        if (!pageOps.debug) {
            var node = pageOps.firstNodeOnPage(pageNo, chaptId);
            //console.log("return node=" + this.getNodeDebugName(node));

            if (node == null) return "NULL-node";
            var fp = node.attr("fp");
            if (fp == null) return "NULL-fp";
            var chapt_node = node.closest("[chapt_id]");
            var result = null;
            if (chapt_node != null && chapt_node.length > 0){
                //console.log("closest chapt_id=" + chapt_node.attr("chapt_id"));
                result = chapt_node.attr("chapt_id") + "," + fp + ",x=" + node.position().left;
            } else {
                //console.log("node chapt_id_ref=" + node.attr("chapt_id_ref"));
                result = node.attr("chapt_id_ref") + "," + fp + ",x=" + node.position().left;
            }
            //console.log("result= " + result);
            return result;
        } else {
            var fp = pageOps.firstNodeOnPage(pageNo, chaptId);
            return fp;
        }
    },

    getFirstFpOnPage_old : function(pageNo, prevFp) {
        var el = $("[fp=" + prevFp + "]");
        if (el.length == 0)
            el = $("[fp]").first();
        if (el.length == 0)
            return null;
        var page = pageOps.getPageForElement(el);
        while(page < pageNo) {
            var el2 = pageOps.nearestFPNode(el, 1);
            if (el2 == null || el2.length == 0) {
                return null;
            }
            el = el2;
            if (el.length == 0)
                return null;  /// out of elements? pageNo outside range
            page = pageOps.getPageForElement(el);
            if (page > pageNo) break;
        }
        return el;
    },

    getFpLocationX : function(chapt_id, fp) {
        console.log("getFpLocationX " + chapt_id + " " + fp);
        var node = null;
        if (fp != null) node = pageOps.getFpNode(chapt_id, fp);
        else node = $("#" + chapt_id);
        var pos = node.position != undefined ? node.position() : null;
        if (pos != null) {
            var s = 0; //$("#content_start").position().left;
            console.log("getFpLocationX Pos " + chapt_id + " " + fp + "Done");
            return pos.left - s;
        }
        else {
            console.log("getFpLocationX Node" + chapt_id + " " + fp + "Done");
             return node;
        }
    },

	getFpLocationY : function(chapt_id, fp) {
        var node = null;
        if (fp != null) node = pageOps.getFpNode(chapt_id, fp);
        else node = $("#" + chapt_id);
        var pos = node.position != undefined ? node.position() : null;
        if (pos != null) {
            var s = 0; //$("#content_start").position().left;
            return pos.top;
        }
        else {
            return node;
        }
    },


    getFpNode : function(chapt_id, fp) {
        console.log("getFpNode reqFp=" + fp + " chapt=" + chapt_id);
        //var node = $("#"+chapt_id);
        //if (node == null || node.length == 0)
        //	return "NULL-chapter";
        //var fnode = node.nextAll().find("[fp=" + fp + "]").first();		
        var fnode = (fp == 0 || (fp == chapt_id + "0")) ? $("#" + chapt_id) 
                                                        : ($("#" + chapt_id + " " + "[fp=" + fp + "]"));
        
        if (fnode == null || fnode.length == 0) {

            fnode = $("#" + chapt_id + " " + "[fp]").filter(function() { return parseInt($(this).attr("fp")) < parseInt(fp); }).last();
            if (fnode == null) {
                fnode = $("#" + chapt_id + " " + "[fp]").filter(function() { return parseInt($(this).attr("fp")) < parseInt(fp); }).first();
            }
            if (fnode != null) {
                console.log("getFpNode reqFp=" + fp + " retFp=" + fnode.attr("fp"));
                return fnode;
            }

            return "NULL-fpnode";
        }
        return fnode;
    },
    
      getPageForFp: function (fp) {
        var el = $("[fp=" + fp + "]");
        return this.getPageForElement(el);
    },
    getPageForLeft: function (left) {
        return left / pagingSize.adjusted_page_width;
    },
    getPageForElement: function (el) {

        var elId = ((el != null) ? 
                    (el.attr('fp') != null ? "fp=" +  el.attr('fp') : "fp=?") + " " +
                    (el.attr('id') != null ? "id=" +  el.attr('id') : "id=?")
                             : "NULL") 
        //console.log("getPageForElement " + elId + " start");

        var pos = (el != null) ? el.position() : null;
        var left = pos.left;
        //var left = (el != null) ? el[0].offsetLeft : null;

        //console.log("getPageForElement position() ack. left=" + left);

        //var l = el[0].offsetLeft;
        //console.log("getPageForElement offsetLeft ack. left=" + l);

        if (/*$("#content_start").position() != null &&*/ left != null) {
            var s = 0; //$("#content_start").position().left;
            var p = pageOps.getPageForLeft(left/* - s*/);
            //console.log("getPageForElement "+ ((el != null) ? el[0].id : "") + " end. p=floor(" + p + ")");
            p = Math.floor(p);
            return p;
        }
    },
    showPageNumbers: function () {
        var h = (pagingSize.height);
        var temp = "<div style='position:absolute; z-index:1; left:{0}; border: solid #008000 1px; text-align:center; " 
        + "top: " + /*$("#content_new").css("padding-top") */ 0 +"px;"
                + "height:" + h + "px; line-height:" + (2 * h - 20) + "px;"
                + "width:" + pagingSize.columnWidth + "px; bottom:0px;'>page {1}</div>";
        var e = $("#content_end");
        var last_page = pageOps.getPageForElement(e);
        var html="";
        for (var i = 0; i <= last_page; i++) {
            var left = pagingSize.adjusted_page_width * i;
            left += pagingSize.columnGap / 2;
            var page_no = pageOps.getPageForLeft(left);
            var text = temp.replace("{0}", left).replace("{1}", "" + i +"(" + page_no + ")");
            html += text;
        }
        $("#page_no").html(html);
    },
//   <div>
//  <div style="position:absolute; left:900px; border: solid green 1px; width:100px; bottom:0px;">page999</div>
//</div>
    
    calculateColumns: function() {
       var columnWidth = pagingSize.columnWidth; //column width + column gap
       var content = $("#content_new");
       //var docContent = document.getElementById("content");
       var info = $("#info");

       //  //get column (= pages count)
       ////  content.css("overflow-x", "scroll");
       var columnCount = (content.width() / columnWidth) | 0 + 1;

       var currPage = 0;
       var left = content.offset().left;
       info.html("total pages = " + columnCount + "<br/>current page = " + (currPage + 1) + "<br/>");
       
       pagingSize.columnsCount = columnCount;
    },

    scrollTo: function (div_id, x) {
        var el = $("#" + div_id);
        if (ipadMode)
            el.css('left', -x);
        else
            el.scrollLeft(x);
    },

    scrollBy: function (div_id, x) {
        var el = $("#" + div_id);
        if (ipadMode)
            el.css('left', parseInt(el.css('left')) - x);
        else
            el.scrollLeft(el.scrollLeft() + x);
    },

     setSize: function (pSize) {
        var mainDiv = $("#mainDiv");
        var paging = $("#content_new");

        pSize.columnWidth = (pSize.page_width - pSize.columnsOnPage * pSize.columnGap) / pSize.columnsOnPage;
        pSize.adjusted_page_width = (pSize.columnWidth + pSize.columnGap + pSize.adjust);
        pagingSize = pSize;

        mainDiv.width(pSize.width);
        $("#Div1").width(pSize.width);
        $("#Div3").width(pSize.width);
        mainDiv.height(pSize.height);

        if (ipadMode)
            paging.width(pSize.width - pSize.columnGap);
        else
            paging.width(pSize.width);

        paging.height(pSize.height);
        
        paging.css("padding-left", pSize.columnGap / 2);
        paging.css("padding-right",pSize.columnGap / 2);

        paging.css("column-width", pSize.columnWidth);
        paging.css("-moz-column-width", pSize.columnWidth);
        paging.css("-webkit-column-width", pSize.columnWidth);

        paging.css("column-gap", pSize.columnGap);
        paging.css("-moz-column-gap", pSize.columnGap);
        paging.css("-webkit-column-gap", pSize.columnGap);

        paging.css("column-width", pSize.columnWidth);
        paging.css("-moz-column-width", pSize.columnWidth);
        paging.css("-webkit-column-width", pSize.columnWidth);

        fixImages("content_new", pSize.columnWidth, pSize.height);
        
//        paging.css("padding-left", (pSize.columnGap / 2) + "px");
//        paging.css("padding-right", (pSize.columnGap / 2) + "px");
        
        //paging.css("margin-right", pSize.columnGap / 2);
    },
    
    pollForSizeChange : function(element, old_h, period) {
        var h = element.height();
        if (h != old_h) {
            serverComm.fireCommand("size_changed", ["id="+element.id]);
        } else {
            window.setTimeout(function() {
                pageOps.pollForSizeChange(element, old_h, period);
            }, period);
        }
    },

    getPagingSize : function() {
            return '' + pagingSize.width + ' ' + pagingSize.page_width 
                                  + ' '+ pagingSize.height + ' ' + pagingSize.columnWidth 
                                      + ' ' + pagingSize.columnGap + ' ' + pagingSize.columnsOnPage
                                      + ' ' + pagingSize.adjust + ' ' + pagingSize.adjusted_page_width;
    },
    
}

/*!
 * jQuery Double Tap Plugin.
 *
 * Copyright (c) 2010 Raul Sanchez (http://www.appcropolis.com)
 *
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 */
 

    // Determine if we on iPhone or iPad
    var isiOS = false;
    var agent = navigator.userAgent.toLowerCase();
    if(agent.indexOf('iphone') >= 0 || agent.indexOf('ipad') >= 0){
           isiOS = true;
    }
 
    jQuery.fn.doubletap = function(onDoubleTapCallback, onTapCallback, delay){
        var eventName, action;
        delay = delay == null? 500 : delay;
        eventName = isiOS == true? 'touchend' : 'click';
 
        $(this).bind(eventName, function(event){
            var now = new Date().getTime();
            var lastTouch = $(this).data('lastTouch') || now + 1 /** the first time this will make delta a negative number */;
            var delta = now - lastTouch;
            clearTimeout(action);
            if(delta<500 && delta>0){
                if(onDoubleTapCallback != null && typeof onDoubleTapCallback == 'function'){
                    onDoubleTapCallback(event);
                }
            }else{
                $(this).data('lastTouch', now);
                action = setTimeout(function(evt){
                    if(onTapCallback != null && typeof onTapCallback == 'function'){
                        onTapCallback(evt);
                    }
                    clearTimeout(action);   // clear the timeout
                }, delay, [event]);
            }
            $(this).data('lastTouch', now);
        });
    };
